=== debian/changelog ===
pocl (1.2-5) unstable; urgency=medium

  * Disable dh_dwz which fails on 32-bit platforms, see #918903.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 05 Feb 2019 00:39:59 +0100

pocl (1.2-4) unstable; urgency=medium

  * Cherry-pick upstream "Fix kernel debug data emission".  (Closes: #919824)
  * Switch to debhelper-compat (= 12).
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 04 Feb 2019 16:08:38 +0100

pocl (1.2-3) experimental; urgency=medium

  * kernel/test_printf: Add more tests.
  * Perform compile test to select -march or -mcpu for clang.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 21 Jan 2019 01:34:24 +0100

pocl (1.2-2) unstable; urgency=medium

  * Update symbols files.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 15 Jan 2019 16:55:49 +0100

pocl (1.2-1) experimental; urgency=medium

  * New upstream release.
  * Remove patches that were applied upstream.
  * Cherry-pick upstream commit fixing LINK_WITH_CLANG.
  * Do not link with --rtlib=compiler-rt at all.
  * Ignore kernel/test_printf failure on i686.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 11 Jan 2019 19:49:24 +0100

pocl (1.2~rc2-1) experimental; urgency=medium

  * New upstream release candidate.
  * Refresh/remove patches.
  * Update symbols files for amd64 and i386.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 07 Sep 2018 19:14:21 +0200

pocl (1.1-9) unstable; urgency=medium

  * Drop unused deprecated module 'sphinx.ext.pngmath'.  (Closes: #918828)
  * Update symbols files.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 10 Jan 2019 00:56:33 +0100

pocl (1.1-8) unstable; urgency=medium

  * Update symbols files.  (Closes: #916024)
  * Fix building in armel chroot on arm64 host.  (Closes: #917244)
  * Switch to debhelper-compat (= 11).
  * Bump Standards-Version to 4.3.0, no changes needed.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 08 Jan 2019 13:04:26 +0100

pocl (1.1-7) unstable; urgency=medium

  * Update symbols files.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 07 Sep 2018 16:04:52 +0200

pocl (1.1-6) experimental; urgency=medium

  * pocl-opencl-icd: Mark as Multi-Arch: same.
  * Fix building in armhf chroot on arm64 host.
  * Bump Standards-Version to 4.2.1, no changes needed.
  * Update symbols files.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 06 Sep 2018 14:11:03 +0200
